import { NormalizedCache } from './store';
import { SelectionSetWithRoot } from '../queries/store';
import { SelectionSet, Document } from 'graphql';
export interface DiffResult {
    result: any;
    isMissing?: 'true';
    missingSelectionSets?: SelectionSetWithRoot[];
}
export declare function diffQueryAgainstStore({store, query, variables}: {
    store: NormalizedCache;
    query: Document;
    variables?: Object;
}): DiffResult;
export declare function diffFragmentAgainstStore({store, fragment, rootId, variables}: {
    store: NormalizedCache;
    fragment: Document;
    rootId: string;
    variables?: Object;
}): DiffResult;
export declare function diffSelectionSetAgainstStore({selectionSet, store, rootId, throwOnMissingField, variables}: {
    selectionSet: SelectionSet;
    store: NormalizedCache;
    rootId: string;
    throwOnMissingField: boolean;
    variables: Object;
}): DiffResult;
